function final_visual(seq, varargin)
color = {[1 0 0], [0 0 1], [0 1 0],  [1 1 0]};
for frame =  1:seq.len
    img = imread(seq.s_frames{frame});
    im_to_show = double(img)/255;
    if size(im_to_show,3) == 1
        im_to_show = repmat(im_to_show, [1 1 3]);
    end
    if frame == 1  %first frame, create GUI
        fig_handle = figure('Name', 'Tracking');
        set(fig_handle, 'Position', [100, 100, size(img,2), size(img,1)]);
    else                        
        figure(fig_handle);
    end
    imagesc(im_to_show);
    hold on;

    for i = 1:length(varargin)
        results = varargin{i};
        result= results(frame,:); 
        if length(result) == 4
            rectangle('Position',result, 'EdgeColor',color{i}, 'LineWidth',2);  
            text(10, 20*i, ['results ' int2str(i)], 'color', color{i});
        elseif  result == [0 0 0 0 0 0 0 0]
            text(10, 20*i, ['results ' int2str(i) ' skip'], 'color', color{i});
        elseif result == [2 0 0 0 0 0 0 0]
            text(10, 20*i, ['results ' int2str(i) ' fail'], 'color', color{i});
        elseif result == [1 0 0 0 0 0 0 0]
            text(10, 20*i, ['results ' int2str(i)], 'color', color{i});
        else
            draw_region(result, color{i}, 2);
            text(10, 20*i, ['results ' int2str(i)], 'color', color{i});
        end
    end
    text(10, 10, [int2str(frame) '  /  ' int2str(seq.len)], 'color', [0 1 1]); 
    hold off;
    axis image;
    drawnow
    pause(0.08)
%     if frame == 47
%         pause
%     end
end
end