function results = new_tracker(params, ground_truth, gt_rects, comp_result)


tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Initialization
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
initialization
disp('initial')
toc
while true
    % Read image
    if seq.frame > 0
        [seq, img] = get_sequence_frame(seq);
        if isempty(img)
            break;
        end
        if size(img,3) > 1 && is_color_image == false
            img = img(:,:,1);
        end
    else
        seq.frame = 1;
    end

    tic();
    
% 	fprintf('frame = %d / %d\n',seq.frame, seq.num_frames)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Do not estimate translation and scaling on the first frame, since we 
    % just want to initialize the tracker there
    if seq.frame > 1
        new_localization
        BBR_localization
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    new_update
%     tbbr = tic;
    BBR_update
%     disp('BBR update')
%     toc(tbbr)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    if params.use_gpu
        refine_pos = gather(refine_pos);
        refine_sz = gather(refine_sz);
    end
    %save position and calculate FPS
    tracking_result.center_pos = double(refine_pos); %%%%%%%%%
    tracking_result.target_size = double(refine_sz); %%%%%%%%
    seq = report_tracking_result(seq, tracking_result);
    
    seq.time = seq.time + toc();
%     disp('every frame time')
%     toc
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % visualization
    new_visual
end

% close(writer);

[seq, results] = get_sequence_results(seq);

disp(['fps: ' num2str(results.fps)])

