    % visualization
    if params.visualization
        rect_position_vis = [refine_pos([2,1]) - (refine_sz([2,1]) - 1)/2, refine_sz([2,1])];
        
        im_to_show = double(img)/255;
        if size(im_to_show,3) == 1
            im_to_show = repmat(im_to_show, [1 1 3]);
        end
        if seq.frame == 1  %first frame, create GUI
            fig_handle = figure('Name', 'Tracking');
            set(fig_handle, 'Position', [100, 100, size(img,2), size(img,1)]);
        else                        
            figure(fig_handle);
        end
        
        imagesc(im_to_show);
        hold on;

        if exist('ground_truth')
            gt= ground_truth(seq.frame,:); 
            draw_region(gt, [1 0 0], 2);
%                 rectangle('Position',gt, 'EdgeColor','r', 'LineWidth',2); 
        end
%         if exist('gt_rects')
%             gt_rect = gt_rects(seq.frame,:);
%             draw_region(gt_rect, [0 0 1], 2);
%         end
        if exist('comp_result')
            comp_rect = comp_result(seq.frame,:);
            if comp_rect == [0 0 0 0 0 0 0 0]
                text(40, 10, 'skip', 'color', [0 1 1]);
            elseif comp_rect == [2 0 0 0 0 0 0 0]
                text(40, 10, 'fail', 'color', [0 1 1]);
            elseif comp_rect ~= [1 0 0 0 0 0 0 0]
                draw_region(comp_rect, [0 1 1], 2);
            end
        end
        rectangle('Position',rect_position_vis, 'EdgeColor','g', 'LineWidth',2);  

        text(10, 10, [int2str(seq.frame) '  /  ' int2str(seq.num_frames)], 'color', [0 1 1]); 
        hold off;
        axis image;
        drawnow
    end