function [seq, ground_truth] = load_video_info(video_path)

ground_truth = dlmread(['VOT_integration/sequences/' video_path '/groundtruth.txt']);
img_path = ['VOT_integration/sequences/' video_path '/color/'];

% seq.format = 'vot';
% seq.format = 'otb';
seq.len = size(ground_truth, 1);
seq.init_rect = ground_truth(1,:); 

if exist([img_path num2str(0, [video_path '-%05i.png'])], 'file'),
    img_files = num2str((0:seq.len-1)', [img_path video_path '-%05i.png']);
elseif exist([img_path num2str(1, '%08i.jpg')], 'file'),
    img_files = num2str((1:seq.len)', [img_path '%08i.jpg']);
elseif exist([img_path num2str(1, '%04i.bmp')], 'file'),
    img_files = num2str((1:seq.len)', [img_path '%04i.bmp']);
else
    error('No image files to load.')
end

seq.s_frames = cellstr(img_files);

end

